Imports System
Imports System.IO
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports System.ComponentModel
Imports System.Windows.Forms
Imports IE = Interop.SHDocVw
 
'Add-in Express .NET for Internet Explorer Module
<ComVisible(True), GuidAttribute("1AE9C8EA-DDDD-46B2-BB25-FF30080B1F91")> _
Public Class IEModule
    Inherits AddinExpress.IE.ADXIEModule
    Implements IWin32Window

    Friend WithEvents AdxieBarItem1 As AddinExpress.IE.ADXIEBarItem
    Friend WithEvents AdxieContextMenuCommandItem1 As AddinExpress.IE.ADXIEContextMenuCommandItem
#Region " Component Designer generated code. "
    'Required by designer
    Private components As System.ComponentModel.IContainer

    'Required by designer - do not modify
    'the following method
    Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container
        Me.AdxieBarItem1 = New AddinExpress.IE.ADXIEBarItem(Me.components)
        Me.AdxieContextMenuCommandItem1 = New AddinExpress.IE.ADXIEContextMenuCommandItem(Me.components)
        '
        'AdxieBarItem1
        '
        Me.AdxieBarItem1.BarType = "DownloadManager.DownloadManager"
        Me.AdxieBarItem1.HelpText = "Download Manager (VB.NET example)"
        Me.AdxieBarItem1.MenuText = "Download Manager (VB.NET example)"
        Me.AdxieBarItem1.Title = "Download Manager (VB.NET example)"
        Me.AdxieBarItem1.ToolButtonActiveIcon = "Icons.favicon"
        '
        'AdxieContextMenuCommandItem1
        '
        Me.AdxieContextMenuCommandItem1.Caption = "Add to Download Manager (VB.NET)"
        Me.AdxieContextMenuCommandItem1.Contexts = CType(((AddinExpress.IE.ADXIEMenuContexts.mcImages Or AddinExpress.IE.ADXIEMenuContexts.mcTextSelection) _
                    Or AddinExpress.IE.ADXIEMenuContexts.mcAnchor), AddinExpress.IE.ADXIEMenuContexts)
        Me.AdxieContextMenuCommandItem1.Items = Nothing
        '
        'IEModule
        '
        Me.Bars.Add(Me.AdxieBarItem1)
        Me.ContextMenu.Add(Me.AdxieContextMenuCommandItem1)
        Me.LoadInMainProcess = False
        Me.ModuleName = "Download Manager (VB.NET)"

    End Sub

#End Region

#Region " Add-in Express automatic code "

    'Required by Add-in Express - do not modify
    'the methods within this region

    Public Overrides Function GetContainer() As System.ComponentModel.IContainer
        If components Is Nothing Then
            components = New System.ComponentModel.Container
        End If
        GetContainer = components
    End Function

    <ComRegisterFunctionAttribute()> _
    Public Shared Sub RegisterIEModule(ByVal t As Type)
        AddinExpress.IE.ADXIEModule.RegisterIEModuleInternal(t)
    End Sub

    <ComUnregisterFunctionAttribute()> _
    Public Shared Sub UnregisterIEModule(ByVal t As Type)
        AddinExpress.IE.ADXIEModule.UnregisterIEModuleInternal(t)
    End Sub

    <ComVisible(True)> _
    Public Class IECustomContextMenuCommands
        Inherits AddinExpress.IE.ADXIEModule.ADXIEContextMenuCommandDispatcher

    End Class

    <ComVisible(True)> _
    Public Class IECustomCommands
        Inherits AddinExpress.IE.ADXIEModule.ADXIECommandDispatcher

    End Class

#End Region

    Public Sub New()
        MyBase.New()

        'This call is required by the Component Designer
        InitializeComponent()

    End Sub

    Public Sub New(ByVal container As IContainer)
        MyBase.New(container)

        container.Add(Me)
        'This call is required by the Component Designer
        InitializeComponent()

    End Sub

    Public ReadOnly Property IEApp() As IE.WebBrowser
        Get
            Return CType(Me.IEObj, IE.WebBrowser)
        End Get
    End Property

    Public ReadOnly Property HTMLDocument() As mshtml.HTMLDocument
        Get
            Return CType(Me.HTMLDocumentObj, mshtml.HTMLDocument)
        End Get
    End Property

    Private Sub AdxieContextMenuCommandItem1_OnClickEx(ByVal sender As System.Object, ByVal e As AddinExpress.IE.ADXIEMenuItemClickEventArgs) Handles AdxieContextMenuCommandItem1.OnClickEx
        Dim module_ As IEModule = _
            AddinExpress.IE.ADXIEModule.CurrentInstance.Item(Me.ThreadID)

        If Not (module_ Is Nothing) Then
            Dim t As Type = System.Type.GetType("DownloadManager.DownloadManager")
            Dim index As Integer = module_.Bars.IndexOf(t.FullName)

            If (index >= 0) Then
                Dim item As AddinExpress.IE.ADXIEBarItem = module_.Bars.Item(index)

                If (item.BarObj Is Nothing) Then
                    Dim g As Object = t.GUID.ToString("B")
                    Dim bShow As Object = True
                    Dim dummy As Object = Nothing

                    IEApp.ShowBrowserBar(g, bShow, dummy)
                Else
                    Dim dm As DownloadManager = item.BarObj

                    If (dm IsNot Nothing) Then
                        If Not dm.Visible Then
                            Dim g As Object = t.GUID.ToString("B")
                            Dim bShow As Object = True
                            Dim dummy As Object = Nothing

                            IEApp.ShowBrowserBar(g, bShow, dummy)
                        End If
                    End If

                End If

                If (TypeOf item.BarObj Is DownloadManager) Then
                    Dim dm As DownloadManager = item.BarObj

                    If (dm.Visible) Then
                        If (dm.Links.Enabled) Then

                            If (TypeOf e.Selection Is mshtml.IHTMLSelectionObject) Then
                                Dim selection As mshtml.IHTMLSelectionObject = e.Selection
                                Dim textRange As mshtml.IHTMLTxtRange = selection.createRange()

                                If (textRange IsNot Nothing) And _
                                    (Not String.IsNullOrEmpty(textRange.text)) And (Not String.IsNullOrEmpty(textRange.htmlText)) Then

                                    Dim linksFound As Boolean = False
                                    Dim text As String = textRange.text
                                    Dim htmlText As String = textRange.htmlText
                                    Dim docObj As Object = New mshtml.HTMLDocument()

                                    docObj.open("text/html", "replace", Nothing, Nothing)
                                    docObj.GetType().InvokeMember( _
                                        "write", BindingFlags.InvokeMethod, Nothing, docObj, New Object() {htmlText})

                                    If (docObj.images.length > 0) Then
                                        Dim attr As Object
                                        Dim src As String = String.Empty

                                        For Each element As mshtml.IHTMLElement In docObj.images
                                            src = String.Empty
                                            attr = element.getAttribute("src", 0)

                                            If (TypeOf attr Is String) Then
                                                src = attr
                                            End If

                                            If (String.IsNullOrEmpty(src)) Then
                                                src = element.getAttribute("href", 0)
                                            End If

                                            If Not String.IsNullOrEmpty(src) Then
                                                Dim file As String = String.Empty

                                                Try
                                                    file = Path.GetFileName(src)
                                                Catch

                                                End Try

                                                If Not String.IsNullOrEmpty(file) Then
                                                    linksFound = True
                                                    dm.AddItem(file, src)
                                                End If
                                            End If
                                        Next

                                    End If

                                    If (docObj.links.length > 0) Then
                                        Dim src As String = String.Empty

                                        For Each element As mshtml.IHTMLAnchorElement In docObj.links
                                            src = element.href

                                            If Not String.IsNullOrEmpty(src) Then
                                                Dim file As String = String.Empty

                                                Try
                                                    file = Path.GetFileName(src)
                                                Catch

                                                End Try

                                                If Not String.IsNullOrEmpty(file) Then
                                                    linksFound = True
                                                    dm.AddItem(file, src)
                                                End If
                                            End If
                                        Next
                                    End If

                                    If (Not linksFound) Then
                                        MessageBox.Show(Me, "There are not valid links in the selection.", "Download Manager Example", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
                                    End If

                                End If
                            Else
                                Dim src As String = String.Empty

                                If (TypeOf e.HTMLElement Is mshtml.IHTMLAnchorElement) Then
                                    Dim element As mshtml.IHTMLAnchorElement = e.HTMLElement
                                    src = element.href
                                ElseIf (TypeOf e.HTMLElement Is mshtml.IHTMLImgElement) Then
                                    Dim element As mshtml.IHTMLImgElement = e.HTMLElement
                                    src = element.href
                                End If

                                If Not String.IsNullOrEmpty(src) Then
                                    If (src.StartsWith("http:")) Then
                                        Dim file As String = String.Empty

                                        Try
                                            file = Path.GetFileName(src)
                                        Catch

                                        End Try

                                        If Not String.IsNullOrEmpty(file) Then
                                            dm.AddItem(file, src)
                                            Return
                                        End If
                                    End If

                                    MessageBox.Show(Me, "The link is not valid.", "Download Manager Example", MessageBoxButtons.OK, MessageBoxIcon.Exclamation)

                                End If
                            End If

                        End If

                    End If

                End If
            End If
        End If
    End Sub

End Class

